<?php
	/*
	 * RSS-Feed-Klasse zum Erstellen eines eigenen RSS-Feeds
	 *
	 * Quelle: http://www-coding.de/eigener-rss-feed-mit-php/
	 * (Hier findest du auch Beispiele und Erklärungen zu dieser PHP-Klasse)
	 *
	 * BEISPIEL:
	 * 		$rss = new RSS('WWW Coding', 'http://www-coding.de', 'Tipps zu JavaScript und PHP', 'de', 1391270457);
	 *		$rss -> addEntry('Artikel 2', 'URL 2', 'Inhalt des Artikels...', 1391270457);	
	 *		$rss -> addEntry('Artikel 1', 'URL 1', 'Inhalt des Artikels...', 1359734457);
	 *		$rss -> Output('feed.xml');	
	 *
	 * (siehe rss_example.php)
	 *
	 */

	class RSS {
		private $rss_code = '';		
		
		// Konstruktor: Erstellt Anfangscodeschnipsel :: $title und $url müssen mindestens übergeben werden //
		public function __construct($title, $url, $description='', $language='de', $lastUpdate=false) {
			$this -> rss_code .= "<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n<rss version=\"2.0\">\n<channel>\n<title>".$title."</title>\n<description>".htmlspecialchars(utf8_encode($description))."</description>\n<language>".$language."</language>\n<link>".$url."</link>\n<lastBuildDate>".date('r', (($lastUpdate) ? $lastUpdate : time()))."</lastBuildDate>\n";
		}
		
		// Hinzufügen eines Eintrags :: $titl, $url und $content müssen mindestens übergeben werden //
		public function addEntry($title, $url, $content, $time = false) {
			$this -> rss_code .= "<item>\n<title>".htmlspecialchars(utf8_encode($title))."</title>\n<description>".htmlspecialchars(utf8_encode($content))." ".$url."</description>\n<link>".$url."</link>\n<pubDate>".date('r', (($time) ? $time : time()))."</pubDate>\n<guid>".$url."</guid>\n</item>\n";
		}
		
		// Output() gibt den Feed Inhalt zurück bzw. Output('/pfad/dateiname.xml') speichert ihn in einer Datei //
		public function Output($file=false) {
			// Abschluss des RSS-Codes //
			$this -> rss_code .= "</channel>\n</rss>";
		
			if ($file) {
				// In Datei speichern //
				$d = fopen($file,'w');
				
				if ($d) {
					// Auf Datei kann zugegriffen werden -> Inhalte schreiben //
					fwrite($d, utf8_decode($this -> rss_code));
					fclose($d);
				}
			} else {
				// Zurückgeben //
				return $this -> rss_code;
			}
		}
	}

?>
